// ==UserScript==
// @name        Twitch-Disable-Embed-Preroll-dec2020
// @namespace   Twitch-Disable-Embed-Preroll-dec2020
// @version     0.0.1
// @author      Nomo
// @description Disable preroll on player.twitch.tv
// @include     *://player.twitch.tv/*
// @require     https://greasemonkey.github.io/gm4-polyfill/gm4-polyfill.js
// @require     https://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js
// @run-at      document-start
// @grant       unsafeWindow
// ==/UserScript==
/* eslint-disable no-undef */
"use strict";
(async () => {
    const origFetch = unsafeWindow.fetch;
    unsafeWindow.fetch = (url, init, ...args) => {
        if (typeof url === "string") {
            if (url.includes("/access_token")) {
                url = url.replace("player_type=embed", "player_type=site");
            } else if (
                url.includes("/gql") &&
                init &&
                typeof init.body === "string" &&
                init.body.includes("PlaybackAccessToken")
            ) {
                const newBody = JSON.parse(init.body);
                newBody.variables.playerType = "site";
                init.body = JSON.stringify(newBody);
            }
        }
        return origFetch(url, init, ...args);
    };
})();